from AccessControl import ClassSecurityInfo
from Globals import InitializeClass
from Products.CMFCore  import CMFCorePermissions
from Products.CMFDefault.SkinnedFolder  import SkinnedFolder
from Referenceable import Referenceable
from ExtensibleMetadata import ExtensibleMetadata
from BaseObject import BaseObject
from debug import log, log_exc

class BaseFolder(BaseObject, Referenceable, SkinnedFolder, ExtensibleMetadata):

    manage_options = SkinnedFolder.manage_options       
    icon = "folder_icon.gif"
    
    def __init__(self, oid, **kwargs):
        #call skinned first cause baseobject will set new defaults on
        #those attributes anyway
        SkinnedFolder.__init__(self, oid, self.Title())
        ExtensibleMetadata.__init__(self, **kwargs)
        BaseObject.__init__(self, oid, **kwargs)


InitializeClass(BaseFolder)

