from AccessControl import ModuleSecurityInfo
from Globals import InitializeClass
from Products.CMFCore  import CMFCorePermissions
from Products.CMFTypes.Generator import generateViews
from Products.CMFTypes.utils import pathFor, capitalize, findDict
from Products.CMFTypes.ClassGen import generateClass
from Products.CMFCore import utils
from Products.CMFCore.DirectoryView import registerDirectory

from copy import deepcopy
from  debug import log
import sys
import os.path

PKG_NAME = "CMFTypes"
INCLUDE_DEMO_TYPES = 0 


registerDirectory('skins', globals())

import I18NLayer
from ContentTool import ContentTool
from GeneratorTool import GeneratorTool, \
                          registerType, \
                          process_types
from GeneratorTool import listTypes as baseListTypes

tools = (
    ContentTool,
    GeneratorTool,
    )


###
## back compat type registration
###
def listTypes(package=None):    
    value = baseListTypes(package)
    value = [v['klass'] for v in value]
    return value

###
## security
###
ModuleSecurityInfo('Products.CMFTypes.debug').declarePublic('log')
ModuleSecurityInfo('Products.CMFTypes.debug').declarePublic('log_exc')

def initialize(context):
    ## This could all go away, in a real site, we wouldn't include the
    ## demo types
    utils.ToolInit("%s Tool" % PKG_NAME, tools=tools,
                   product_name=PKG_NAME,
                   icon="tool.gif",
                   ).initialize(context)

    if INCLUDE_DEMO_TYPES:
        import cmf_types        

        content_types, constructors, ftis = process_types(
            listTypes(), PKG_NAME)
        
        utils.ContentInit(
            '%s Content' % PKG_NAME,
            content_types = content_types,
            permission = CMFCorePermissions.AddPortalContent,
            extra_constructors = constructors,
            fti = ftis,
            ).initialize(context)

    utils.ContentInit(
	    '%s I18NLayer Content' % PKG_NAME,
	    content_types = ( I18NLayer, ),
	    permission = CMFCorePermissions.AddPortalContent,
	    extra_constructors = (I18NLayer.addI18NLayer, ),
	    fti = (I18NLayer.factory_type_information, ),
	    ).initialize(context)




types_globals=globals()
